Index: issm/trunk/src/c/analyses/GLheightadvectionAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/GLheightadvectionAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/GLheightadvectionAnalysis.cpp	(revision 26744)
@@ -47,4 +47,7 @@
 /*Finite Element Analysis*/
 void           GLheightadvectionAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           GLheightadvectionAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -90,5 +93,4 @@
 	IssmDouble*    basis  = xNew<IssmDouble>(numnodes);
 	IssmDouble*    dbasis = xNew<IssmDouble>(dim*numnodes);
-	IssmDouble*    Bprime = xNew<IssmDouble>(dim*numnodes);
 	IssmDouble     D[2][2] = {0.};
 
@@ -175,5 +177,5 @@
 	xDelete<IssmDouble>(dbasis);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return Ke;
 
Index: issm/trunk/src/c/analyses/GLheightadvectionAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/GLheightadvectionAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/GLheightadvectionAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 26744)
@@ -156,4 +156,7 @@
 	_error_("not implemented");
 }/*}}}*/
+void HydrologyDCEfficientAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* HydrologyDCEfficientAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
@@ -186,8 +189,5 @@
 	/*Check that all nodes are active, else return empty matrix*/
 	if(!active_element) {
-		if(domaintype!=Domain2DhorizontalEnum){
-			basalelement->DeleteMaterials();
-			delete basalelement;
-		}
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 		return NULL;
 	}
@@ -247,5 +247,5 @@
 	xDelete<IssmDouble>(dbasis);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return Ke;
 }/*}}}*/
@@ -274,8 +274,5 @@
 	/*Check that all nodes are active, else return empty matrix*/
 	if(!active_element) {
-		if(domaintype!=Domain2DhorizontalEnum){
-			basalelement->DeleteMaterials();
-			delete basalelement;
-		}
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 		return NULL;
 	}
@@ -376,5 +373,5 @@
 	xDelete<IssmDouble>(basis);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return pe;
 }/*}}}*/
@@ -425,5 +422,5 @@
 	xDelete<IssmDouble>(eplHeads);
 	xDelete<int>(doflist);
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 } /*}}}*/
 void HydrologyDCEfficientAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/
@@ -538,5 +535,4 @@
 	int iseplthickcomp;
 
-
 	/*Skip if we don't want to compute thicknesses*/
 	femmodel->parameters->FindParam(&iseplthickcomp,HydrologydcEplThickCompEnum);
@@ -561,5 +557,4 @@
 	femmodel->parameters->FindParam(&gravity,ConstantsGEnum);
 	femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
-
 
 	for(Object* & object : femmodel->elements->objects){
@@ -733,8 +728,5 @@
 	element->AddBasalInput(HydrologydcEplThicknessSubstepEnum,epl_thickness,basalelement->GetElementType());
 
-	if(domaintype!=Domain2DhorizontalEnum){
-		basalelement->DeleteMaterials();
-		delete basalelement;
-	}
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	xDelete<IssmDouble>(epl_thickness);
 	xDelete<IssmDouble>(old_active);
@@ -788,5 +780,5 @@
 		/*Do not do anything: at least one node is active for this element but this element is not solved for*/
 	}
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	xDelete<IssmDouble>(active);
 }
Index: issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.h	(revision 26744)
@@ -25,4 +25,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 26744)
@@ -178,4 +178,7 @@
 	_error_("not implemented");
 }/*}}}*/
+void           HydrologyDCInefficientAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* HydrologyDCInefficientAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
@@ -209,8 +212,5 @@
 	/*Check that all nodes are active, else return empty matrix*/
 	if(!thawed_element) {
-		if(domaintype!=Domain2DhorizontalEnum){
-			basalelement->DeleteMaterials();
-			delete basalelement;
-		}
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 		return NULL;
 	}
@@ -280,8 +280,5 @@
 	xDelete<IssmDouble>(dbasis);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){
-		basalelement->DeleteMaterials();
-		delete basalelement;
-	}
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return Ke;
 }/*}}}*/
@@ -310,8 +307,5 @@
 	/*Check that all nodes are active, else return empty matrix*/
 	if(!thawed_element) {
-	if(domaintype!=Domain2DhorizontalEnum){
-			basalelement->DeleteMaterials();
-			delete basalelement;
-		}
+		if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 		return NULL;
 	}
@@ -437,8 +431,5 @@
 	xDelete<IssmDouble>(basis);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){
-		basalelement->DeleteMaterials();
-		delete basalelement;
-	}
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return pe;
 }/*}}}*/
@@ -532,8 +523,5 @@
 	xDelete<IssmDouble>(pressure);
 	xDelete<int>(doflist);
-	if(domaintype!=Domain2DhorizontalEnum){
-		basalelement->DeleteMaterials();
-		delete basalelement;
-	}
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void HydrologyDCInefficientAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/
@@ -735,8 +723,5 @@
 	}
 
-	if(domaintype!=Domain2DhorizontalEnum){
-		basalelement->DeleteMaterials();
-		delete basalelement;
-	}
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	xDelete<IssmDouble>(meltingrate);
 	xDelete<IssmDouble>(groundedice);
@@ -804,5 +789,5 @@
 		/*Do not do anything: at least one node is active for this element but this element is not solved for*/
 	}
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	xDelete<IssmDouble>(active);
 }
Index: issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.h	(revision 26744)
@@ -23,4 +23,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/HydrologyGlaDSAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyGlaDSAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyGlaDSAnalysis.cpp	(revision 26744)
@@ -129,5 +129,5 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.bed",BedEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0); /*Needed for friction*/
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.geothermalflux",BasalforcingsGeothermalfluxEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum);
@@ -144,7 +144,14 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.watercolumn",HydrologySheetThicknessEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.hydraulic_potential",HydraulicPotentialEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vy",VyEnum);
-	iomodel->FindConstant(&frictionlaw,"md.friction.law");
+	if(iomodel->domaintype==Domain2DhorizontalEnum){
+		iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxBaseEnum);
+		iomodel->FetchDataToInput(inputs,elements,"md.initialization.vy",VyBaseEnum);
+		iomodel->FindConstant(&frictionlaw,"md.friction.law");
+	}
+	else{
+		iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxEnum);
+		iomodel->FetchDataToInput(inputs,elements,"md.initialization.vy",VyEnum);
+		iomodel->FindConstant(&frictionlaw,"md.friction.law");
+	}
 
 	/*Friction law variables*/
@@ -213,4 +220,7 @@
 /*Finite Element Analysis*/
 void           HydrologyGlaDSAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           HydrologyGlaDSAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -322,5 +332,5 @@
 
 	/*Skip if water or ice shelf element*/
-	if(element->IsFloating()) return NULL;
+	if(element->IsAllFloating()) return NULL;
 
 	/*Intermediaries */
@@ -350,6 +360,4 @@
 	IssmDouble e_v       = element->FindParam(HydrologyEnglacialVoidRatioEnum);
 	Input* hr_input     = element->GetInput(HydrologyBumpHeightEnum);_assert_(hr_input);
-	Input* vx_input     = element->GetInput(VxEnum);_assert_(vx_input);
-	Input* vy_input     = element->GetInput(VyEnum);_assert_(vy_input);
 	Input* h_input      = element->GetInput(HydrologySheetThicknessEnum);_assert_(h_input);
 	Input* H_input      = element->GetInput(ThicknessEnum); _assert_(H_input);
@@ -373,6 +381,4 @@
 
 		/*Get input values at gauss points*/
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
 		h_input->GetInputValue(&h,gauss);
 		G_input->GetInputValue(&G,gauss);
@@ -385,4 +391,5 @@
 
 		/*Get basal velocity*/
+		friction->GetBasalSlidingSpeeds(&vx, &vy ,gauss);
 		ub = sqrt(vx*vx + vy*vy);
 
@@ -465,5 +472,5 @@
 
 	/*Skip if water or ice shelf element*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 
 	/*Intermediaries */
@@ -485,6 +492,6 @@
 	IssmDouble g         = element->FindParam(ConstantsGEnum);
 	Input* hr_input = element->GetInput(HydrologyBumpHeightEnum);_assert_(hr_input);
-	Input* vx_input = element->GetInput(VxEnum);_assert_(vx_input);
-	Input* vy_input = element->GetInput(VyEnum);_assert_(vy_input);
+	Input* vx_input = element->GetInput(VxBaseEnum);_assert_(vx_input);
+	Input* vy_input = element->GetInput(VyBaseEnum);_assert_(vy_input);
 	Input* H_input  = element->GetInput(ThicknessEnum); _assert_(H_input);
 	Input* b_input  = element->GetInput(BedEnum); _assert_(b_input);
@@ -554,6 +561,6 @@
 
 	/*Skip if water or ice shelf element*/
-	if(element->IsFloating()) return;
-	
+	if(element->IsAllFloating()) return;
+
 	/*Intermediary*/
 	IssmDouble phi_0, phi_m, p_i;
Index: issm/trunk/src/c/analyses/HydrologyGlaDSAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyGlaDSAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyGlaDSAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/HydrologyPismAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyPismAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyPismAnalysis.cpp	(revision 26744)
@@ -64,4 +64,7 @@
 	_error_("not implemented");
 }/*}}}*/
+void           HydrologyPismAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* HydrologyPismAnalysis::CreateDVector(Element* element){/*{{{*/
 	_error_("not implemented");
@@ -101,5 +104,5 @@
 
 	/*Skip if water or ice shelf element*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 
 	/*Intermediaries */
@@ -131,5 +134,5 @@
 
 	/* Divide by connectivity, add degree of channelization as an input */
-	/*FIXME: should be changed to P1, this is due to the NR, IsFloating will return 0 on this element, but it should not be DG*/
+	/*FIXME: should be changed to P1, this is due to the NR, IsAllFloating will return 0 on this element, but it should not be DG*/
 	element->AddInput(WatercolumnEnum,&watercolumn[0],P1DGEnum);
 
Index: issm/trunk/src/c/analyses/HydrologyPismAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyPismAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyPismAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/HydrologyShaktiAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyShaktiAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyShaktiAnalysis.cpp	(revision 26744)
@@ -119,4 +119,8 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vy",VyEnum);
+	if(iomodel->domaintype==Domain2DhorizontalEnum){
+		iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxBaseEnum);
+		iomodel->FetchDataToInput(inputs,elements,"md.initialization.vy",VyBaseEnum);
+	}
 	iomodel->FindConstant(&frictionlaw,"md.friction.law");
 
@@ -151,4 +155,25 @@
 	parameters->AddObject(iomodel->CopyConstantObject("md.hydrology.storage",HydrologyStorageEnum));
 
+	/*Deal with friction parameters*/
+	int frictionlaw;
+	iomodel->FindConstant(&frictionlaw,"md.friction.law");
+	if(frictionlaw==6){
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.gamma",FrictionGammaEnum));
+	}
+	if(frictionlaw==4){
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.gamma",FrictionGammaEnum));
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.coupling",FrictionCouplingEnum));
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.effective_pressure_limit",FrictionEffectivePressureLimitEnum));
+	}
+	if(frictionlaw==1 || frictionlaw==3 || frictionlaw==7){
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.coupling",FrictionCouplingEnum));
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.effective_pressure_limit",FrictionEffectivePressureLimitEnum));
+	}
+	if(frictionlaw==9){
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.gamma",FrictionGammaEnum));
+		parameters->AddObject(iomodel->CopyConstantObject("md.friction.effective_pressure_limit",FrictionEffectivePressureLimitEnum));
+		parameters->AddObject(new IntParam(FrictionCouplingEnum,0));
+	}
+
   /*Requested outputs*/
   iomodel->FindConstant(&requestedoutputs,&numoutputs,"md.hydrology.requested_outputs");
@@ -162,4 +187,7 @@
 	_error_("not implemented");
 }/*}}}*/
+void           HydrologyShaktiAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* HydrologyShaktiAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
@@ -174,4 +202,5 @@
 	IssmDouble Jdet;
 	IssmDouble* xyz_list = NULL;
+	IssmDouble  gap,bed,thickness,head,g,rho_ice,rho_water,A,B,n;
 
 	/*Fetch number of nodes and dof for this finite element*/
@@ -194,4 +223,15 @@
 	element->FindParam(&dt,TimesteppingTimeStepEnum);
 
+        /*Get all inputs and parameters*/
+        element->FindParam(&rho_water,MaterialsRhoFreshwaterEnum);
+        element->FindParam(&rho_ice,MaterialsRhoIceEnum);
+        element->FindParam(&g,ConstantsGEnum);
+        Input* B_input = element->GetInput(MaterialsRheologyBEnum);         _assert_(B_input);
+        Input* n_input = element->GetInput(MaterialsRheologyNEnum);         _assert_(n_input);
+        Input* gap_input = element->GetInput(HydrologyGapHeightEnum);         _assert_(gap_input);
+        Input* thickness_input = element->GetInput(ThicknessEnum);                  _assert_(thickness_input);
+        Input* head_input = element->GetInput(HydrologyHeadEnum);              _assert_(head_input);
+        Input* base_input = element->GetInput(BaseEnum);                      _assert_(base_input);
+
 	/* Start  looping on the number of gaussian points: */
 	Gauss* gauss=element->NewGauss(1);
@@ -202,8 +242,27 @@
 		element->NodalFunctions(basis,gauss);
 
+		/***/
+                base_input->GetInputValue(&bed,gauss);
+                thickness_input->GetInputValue(&thickness,gauss);
+                gap_input->GetInputValue(&gap,gauss);
+                head_input->GetInputValue(&head,gauss);
+
+                /*Get ice A parameter*/
+                B_input->GetInputValue(&B,gauss);
+                n_input->GetInputValue(&n,gauss);
+                A=pow(B,-n);
+
+                /*Get water and ice pressures*/
+                IssmDouble pressure_ice   = rho_ice*g*thickness;    _assert_(pressure_ice>0.);
+                IssmDouble pressure_water = rho_water*g*(head-bed);
+                if(pressure_water>pressure_ice) pressure_water = pressure_ice;
+
+
+
 		for(int i=0;i<numnodes;i++){
 			for(int j=0;j<numnodes;j++){
 				Ke->values[i*numnodes+j] += conductivity*gauss->weight*Jdet*(dbasis[0*numnodes+i]*dbasis[0*numnodes+j] + dbasis[1*numnodes+i]*dbasis[1*numnodes+j])
-				  + gauss->weight*Jdet*storage/dt*basis[i]*basis[j];
+				  + gauss->weight*Jdet*storage/dt*basis[i]*basis[j]
+                			+gauss->weight*Jdet*A*(n)*(pow(fabs(pressure_ice-pressure_water),(n-1))*rho_water*g)*gap*basis[i]*basis[j];
 			}
 		}
@@ -220,13 +279,15 @@
 
 	/*Skip if water or ice shelf element*/
-	if(element->IsFloating()) return NULL;
+	if(element->IsAllFloating()) return NULL;
 
 	/*Intermediaries */
 	IssmDouble  Jdet,meltrate,G,dh[2],B,A,n;
 	IssmDouble  gap,bed,thickness,head,ieb,head_old;
-	IssmDouble  lr,br,vx,vy,beta;
+	IssmDouble  lr,br,vx,vy,beta,lc;
 	IssmDouble  alpha2,frictionheat;
    IssmDouble  PMPheat,dpressure_water[2],dbed[2];	
 	IssmDouble* xyz_list = NULL;
+//        IssmDouble dgapxx; /***/
+//	IssmDouble dgapyy; /***/
 
 	/*Fetch number of nodes and dof for this finite element*/
@@ -251,9 +312,9 @@
 	Input* n_input              = element->GetInput(MaterialsRheologyNEnum);         _assert_(n_input);
 	Input* englacial_input      = element->GetInput(HydrologyEnglacialInputEnum);    _assert_(englacial_input);
-	Input* vx_input             = element->GetInput(VxEnum);                         _assert_(vx_input);
-	Input* vy_input             = element->GetInput(VyEnum);                         _assert_(vy_input);
 	Input* lr_input             = element->GetInput(HydrologyBumpSpacingEnum);       _assert_(lr_input);
 	Input* br_input             = element->GetInput(HydrologyBumpHeightEnum);        _assert_(br_input);
    Input* headold_input        = element->GetInput(HydrologyHeadOldEnum);           _assert_(headold_input);
+//	Input* dgapxx_input	    = element->GetInput(HydrologyGapHeightXXEnum); /***/
+//	Input* dgapyy_input	    = element->GetInput(HydrologyGapHeightYYEnum); /***/
 
 	/*Get conductivity from inputs*/
@@ -284,7 +345,7 @@
 		lr_input->GetInputValue(&lr,gauss);
 		br_input->GetInputValue(&br,gauss);
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
-      headold_input->GetInputValue(&head_old,gauss);
+                headold_input->GetInputValue(&head_old,gauss);
+//		dgapxx_input->GetInputValue(&dgapxx,gauss); /***/
+//		dgapyy_input->GetInputValue(&dgapyy,gauss); /***/
 
 		/*Get ice A parameter*/
@@ -301,7 +362,10 @@
 		/*Compute frictional heat flux*/
 		friction->GetAlpha2(&alpha2,gauss);
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
+		friction->GetBasalSlidingSpeeds(&vx, &vy, gauss);
 		frictionheat=alpha2*(vx*vx+vy*vy);
+
+		/* Take out frictional heat for large gap height */
+		if(gap>br)
+		 frictionheat=0.;
 
 		/*Get water and ice pressures*/
@@ -322,12 +386,27 @@
 		_assert_(meltrate>0.);
 
-		for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*
-		 (
-		  meltrate*(1/rho_water-1/rho_ice)
-		  +A*pow(fabs(pressure_ice - pressure_water),n-1)*(pressure_ice - pressure_water)*gap
-		  -beta*sqrt(vx*vx+vy*vy)
-		  +ieb
-		  +storage*head_old/dt
-		  )*basis[i];     	
+                  for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*
+                   (
+                    meltrate*(1/rho_water-1/rho_ice)
+                    +A*pow(fabs(pressure_ice - pressure_water),n-1)*(pressure_ice + rho_water*g*bed)*gap
+                    +(n-1)*A*pow(fabs(pressure_ice - pressure_water),n-1)*(rho_water*g*head)*gap
+                    -beta*sqrt(vx*vx+vy*vy)
+                    +ieb
+                    +storage*head_old/dt
+                    )*basis[i];
+
+                /* Test with experimental diffusivity term*/
+//                   for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*
+ //                   (
+  //                   meltrate*(1/rho_water-1/rho_ice)
+   //                  +A*pow(fabs(pressure_ice - pressure_water),n-1)*(pressure_ice + rho_water*g*bed)*gap
+    //                 +(n-1)*A*pow(fabs(pressure_ice - pressure_water),n-1)*(rho_water*g*head)*gap
+     //                -beta*sqrt(vx*vx+vy*vy)
+      //               +ieb
+       //              +storage*head_old/dt
+        //             +0.e-5*(dgapxx+dgapyy)
+         //            )*basis[i];
+
+	
 	}
 	/*Clean up and return*/
@@ -362,5 +441,4 @@
 
 	/*Get thickness and base on nodes to apply cap on water head*/
-   IssmDouble* eff_pressure = xNew<IssmDouble>(numnodes);
 	IssmDouble* thickness = xNew<IssmDouble>(numnodes);
 	IssmDouble* bed       = xNew<IssmDouble>(numnodes);
@@ -380,20 +458,17 @@
 		values[i]=solution[doflist[i]];
 
-		/*make sure that p_water<p_ice ->  h<rho_i H/rho_w + zb*/
-		if(values[i]>rho_ice*thickness[i]/rho_water+bed[i]){
-			values[i] = rho_ice*thickness[i]/rho_water+bed[i];
-		}
+		/*overburden cap: make sure that p_water<p_ice ->  h<rho_i H/rho_w + zb*/
+//		if(values[i]>rho_ice*thickness[i]/rho_water+bed[i]){
+//			values[i] = rho_ice*thickness[i]/rho_water+bed[i];
+//		}
 
 		/*Make sure that negative pressure is not allowed*/
-  //    if(values[i]<bed[i]){
-	//		values[i] = bed[i];
-	//	}
+//      if(values[i]<bed[i]){
+//			values[i] = bed[i];
+//		}
 
 		/*Under-relaxation*/
 	   values[i] = head_old[i] - relaxation*(head_old[i]-values[i]);
 
-		/*Calculate effective pressure*/
-		eff_pressure[i] = rho_ice*g*thickness[i] - rho_water*g*(values[i]-bed[i]);
-
 		if(xIsNan<IssmDouble>(values[i])) _error_("NaN found in solution vector");
 		if(xIsInf<IssmDouble>(values[i])) _error_("Inf found in solution vector");
@@ -402,5 +477,4 @@
 	/*Add input to the element: */
 	element->AddInput(HydrologyHeadEnum,values,element->GetElementType());
-   element->AddInput(EffectivePressureEnum,eff_pressure,P1Enum);
 
 	/*Update reynolds number according to new solution*/
@@ -416,4 +490,7 @@
 	IssmDouble reynolds = conductivity*sqrt(dh[0]*dh[0]+dh[1]*dh[1])/NU;
 	element->AddInput(HydrologyReynoldsEnum,&reynolds,P0Enum);
+
+   /*Compute new effective pressure*/
+   this->UpdateEffectivePressure(element);
 
 	/*Free resources:*/
@@ -423,5 +500,4 @@
 	xDelete<IssmDouble>(xyz_list);
 	xDelete<int>(doflist);
-	xDelete<IssmDouble>(eff_pressure);
    xDelete<IssmDouble>(head_old);
 }/*}}}*/
@@ -464,5 +540,5 @@
 
 	/*Skip if water or ice shelf element*/
-	if(element->IsFloating()) return;
+	if(element->IsAllFloating()) return;
 
 	/*Intermediaries */
@@ -470,5 +546,5 @@
 	IssmDouble  Jdet,meltrate,G,dh[2],B,A,n,dt;
 	IssmDouble  gap,bed,thickness,head;
-	IssmDouble  lr,br,vx,vy,beta;
+	IssmDouble  lr,br,vx,vy,beta,lc;
 	IssmDouble  alpha2,frictionheat;
 	IssmDouble* xyz_list = NULL;
@@ -476,4 +552,6 @@
 	IssmDouble q = 0.;
    IssmDouble channelization = 0.;
+//	IssmDouble dgapxx; /***/
+//	IssmDouble dgapyy; /***/
 
 	/*Retrieve all inputs and parameters*/
@@ -491,8 +569,8 @@
 	Input* B_input              = element->GetInput(MaterialsRheologyBEnum);         _assert_(B_input);
 	Input* n_input              = element->GetInput(MaterialsRheologyNEnum);         _assert_(n_input);
-	Input* vx_input             = element->GetInput(VxEnum);                         _assert_(vx_input);
-	Input* vy_input             = element->GetInput(VyEnum);                         _assert_(vy_input);
 	Input* lr_input             = element->GetInput(HydrologyBumpSpacingEnum);       _assert_(lr_input);
 	Input* br_input             = element->GetInput(HydrologyBumpHeightEnum);        _assert_(br_input);
+ //       Input* dgapxx_input         = element->GetInput(HydrologyGapHeightXXEnum); /***/
+  //      Input* dgapyy_input         = element->GetInput(HydrologyGapHeightYYEnum); /***/
 
 	/*Get conductivity from inputs*/
@@ -520,6 +598,6 @@
 		lr_input->GetInputValue(&lr,gauss);
 		br_input->GetInputValue(&br,gauss);
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
+//		dgapxx_input->GetInputValue(&dgapxx,gauss); /***/
+//		dgapyy_input->GetInputValue(&dgapyy,gauss); /***/
 
 		/*Get ice A parameter*/
@@ -536,7 +614,10 @@
 		/*Compute frictional heat flux*/
 		friction->GetAlpha2(&alpha2,gauss);
-		vx_input->GetInputValue(&vx,gauss);
-		vy_input->GetInputValue(&vy,gauss);
+		friction->GetBasalSlidingSpeeds(&vx, &vy, gauss);
 		frictionheat=alpha2*(vx*vx+vy*vy);
+
+		/* Take out frictional heat for large gap height */
+		if(gap>br)
+		 frictionheat=0.;
 
 		/*Get water and ice pressures*/
@@ -558,4 +639,14 @@
 					+beta*sqrt(vx*vx+vy*vy)
 					));
+
+		/* TEST with experimental gap height "diffusivity" for melting walls */
+//                newgap += gauss->weight*Jdet*(gap+dt*(
+ //                                        meltrate/rho_ice
+  //                                       -A*pow(fabs(pressure_ice-pressure_water),n-1)*(pressure_ice-pressure_water)*lc
+   //                                      +beta*sqrt(vx*vx+vy*vy)
+//					 +0.e-5*(dgapxx+dgapyy))
+ //                                        );
+
+
 		totalweights +=gauss->weight*Jdet;
 
@@ -592,2 +683,49 @@
 	delete gauss;
 }/*}}}*/
+void HydrologyShaktiAnalysis::UpdateEffectivePressure(FemModel* femmodel){/*{{{*/
+
+	for(Object* & object : femmodel->elements->objects){
+		Element* element=xDynamicCast<Element*>(object);
+		UpdateEffectivePressure(element);
+	}
+
+}/*}}}*/
+void HydrologyShaktiAnalysis::UpdateEffectivePressure(Element* element){/*{{{*/
+
+	/*Skip if water or ice shelf element*/
+	if(element->IsAllFloating()) return;
+
+	/*Intermediaries*/
+	IssmDouble bed,thickness,head;
+
+	/* Fetch number of nodes and allocate output*/
+   int numnodes = element->GetNumberOfNodes();
+   IssmDouble* N = xNew<IssmDouble>(numnodes);
+
+	/*Retrieve all inputs and parameters*/
+	IssmDouble  g          = element->FindParam(ConstantsGEnum);
+	IssmDouble  rho_ice    = element->FindParam(MaterialsRhoIceEnum);
+	IssmDouble  rho_water  = element->FindParam(MaterialsRhoFreshwaterEnum);
+	Input* head_input      = element->GetInput(HydrologyHeadEnum); _assert_(head_input);
+	Input* thickness_input = element->GetInput(ThicknessEnum);     _assert_(thickness_input);
+	Input* base_input      = element->GetInput(BaseEnum);          _assert_(base_input);
+
+
+   Gauss* gauss=element->NewGauss();
+   for (int i=0;i<numnodes;i++){
+      gauss->GaussNode(element->GetElementType(),i);
+
+		base_input->GetInputValue(&bed,gauss);
+		thickness_input->GetInputValue(&thickness,gauss);
+		head_input->GetInputValue(&head,gauss);
+
+		N[i] = rho_ice*g*thickness - rho_water*g*(head-bed);
+	}
+
+	/*Add new gap as an input*/
+	element->AddInput(EffectivePressureEnum,N,element->GetElementType());
+
+	/*Clean up and return*/
+   xDelete<IssmDouble>(N);
+	delete gauss;
+}/*}}}*/
Index: issm/trunk/src/c/analyses/HydrologyShaktiAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyShaktiAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/HydrologyShaktiAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
@@ -35,4 +36,6 @@
 		void UpdateGapHeight(FemModel* femmodel);
 		void UpdateGapHeight(Element* element);
+		void UpdateEffectivePressure(FemModel* femmodel);
+		void UpdateEffectivePressure(Element* element);
 };
 #endif
